package com.cassandraguide.rw;

import java.util.ArrayList;
import java.util.List;

import org.apache.cassandra.thrift.Cassandra;
import org.apache.cassandra.thrift.Column;
import org.apache.cassandra.thrift.ColumnOrSuperColumn;
import org.apache.cassandra.thrift.ColumnParent;
import org.apache.cassandra.thrift.ConsistencyLevel;
import org.apache.cassandra.thrift.SlicePredicate;

public class SlicePredicateExample {
	
	public static void main(String[] args) throws Exception {
		Connector conn = new Connector();
		Cassandra.Client client = conn.connect();
		
		SlicePredicate predicate = new SlicePredicate();
		List<byte[]> colNames = new ArrayList<byte[]>();
		colNames.add("a".getBytes());
		colNames.add("b".getBytes());
		predicate.column_names = colNames;
		
		ColumnParent parent = new ColumnParent("Standard1");

		byte[] key = "k1".getBytes();
		List<ColumnOrSuperColumn> results = 
			client.get_slice(key, parent, predicate, ConsistencyLevel.ONE);
		
		for (ColumnOrSuperColumn cosc : results) {	
			Column c = cosc.column;
			System.out.println(new String(c.name, "UTF-8") + " : "
					+ new String(c.value, "UTF-8"));
		}
				
		conn.close();
		
		System.out.println("All done.");
	}
}
